Description

One of the most often action when working with issues is to change the issue status and in the current Ul, depending on the context,
you can do this in two ways:

1. Using the context menu wherever the issues are listed (Issues, My Page, Subtasks, Related issues, etc).

2. Using "Edit" button from the issue page.

From my experience, the second option is generally used because the normal flow is to open first the issue and then change the
status. In a very simple scenario, this action requires at least 4 clicks: click Edit to open edit form, click to open Status dropdown,
click to select the new status and then click Submit.

The scope of this feature is to discuss and find a better Ul feature to allow users to change the issue status with less clicks and using
a method that is focused on the issue transition, not a general Edit mode which can be quite overwhelming for some users (#3143 is
caused by the same "Edit" mode and it's a long requested feature).

| thought at three approaches:

1. Buttons for each available status displayed under the issue subject:
status_buttons.png

2. New button "Change status" in the contextual area:
change_status_button.png

3. Display the issue status as a custom dropdown and on click, show the dropdown with the available statuses:
status_dropdown.png

4. Based on #33254, as a badge dropwdown:
dropdown_badge.png

In a first iteration, clicking on the issue status will work in the same way as clicking on the new status from the context menu where
the issue edit form is displayed in case of any validation error. In the future, this new "Ul feature" can be develop in order to allow
users to fill in the mandatory fields or to add a note before submitting the issue.

Based on the current Ul, | think the second option with the "Change status” icon is more appropriate. Any feedback is welcome!

Related issues:

Related to Redmine - Feature #28829: Add right-click context menu to the cont... Reopened
Related to Redmine - Feature #33254: Show open/closed badge on issue page Closed
History

#1 - 2020-03-16 00:46 - Marius BALTEANU

- Related to Feature #28829: Add right-click context menu to the contextual area of an issue added

#2 - 2020-03-16 07:12 - Mizuki ISHIKAWA

+1

I like 1 because it seems that | can change the status the quickest(one click).
Whichever approach you take from 1 to 3, | think it will be a useful feature that many people use!

#3 - 2020-03-16 07:39 - pasquale [:dedalus]

Hi Marius, this is a good step forward.
https://www.redmine.org/issues/3143
https://www.redmine.org/issues/33254

Have you evalueted the jira edit approach implemented by this plugin Dynamic edit?
Thanks for your work.

#4 - 2020-03-16 13:11 - Robert Schneider

Hm... | always missed that feature.

However, it would be much better if the assignee could be set in the same step. E.g.: when | choose status 'solved' the assigne should be
automatically set to QA. Or it should be selectable who will be the assignee (the ones which are allowed by the workflow settings). If | can set it only
to 'solved' then | have to edit the issue a second time to choose the assignee. And my guess is that many would like to set the status and the
assignee at the same time.

That makes things more complex, | guess. But that would be very desirable. At least for the use in our company.

#5 - 2020-03-16 17:11 - Yuuki NARA

+1

| agree with improving the Redmine Ul.

As an implementation of 1, there is a status_button plugin.
https://www.redmine.org/plugins/status_button

It is useful as a simple workflow system.
If the issue creator sets an approver, the approver proceeds by simply pressing the next status.
It reflects the permissions and roles on Redmine.

| just modified it for Redmine4.1.
https://github.com/y503unavailable/status_button

However, sufficient testing has not yet been completed.
| hope anyone can try it. :-)

#6 - 2020-04-05 13:30 - Marius BALTEANU
- File dropdown_badge.png added

- Description updated

#7 - 2020-04-05 13:48 - Marius BALTEANU

| have added a new proposal based on #33254.
pasquale [:dedalus] wrote:

Have you evalueted the jira edit approach implemented by this plugin Dynamic edit?

Yes, | know the plugin and in the past, | started to build a similar plugin, but I've never finished because | found it complex to maintain. Regarding
inline editing of each attribute, the change it's quite huge and I'm not sure if it's the best option, maybe it's enough to have a more Linkedin edit
mechanism for each section (attributes, description, each full width custom field). Anyway, there are different features and we need a validation first
from Jean-Philippe. One more thing, from what | know, even Jira in new version (8) has a status dropdown to change the status, but I'm not 100%
sure how it works.

Robert Schneider wrote:
Hm... | always missed that feature.

However, it would be much better if the assignee could be set in the same step. E.g.: when | choose status 'solved' the assigne should be
automatically set to QA. Or it should be selectable who will be the assignee (the ones which are allowed by the workflow settings). If | can set it
only to 'solved' then | have to edit the issue a second time to choose the assignee. And my guess is that many would like to set the status and
the assignee at the same time.

That makes things more complex, | guess. But that would be very desirable. At least for the use in our company.

Indeed, it is getting much more complicated to support this because it depends a lot on the workflow. Maybe for some users/companies the Assignee
field makes sense, but for other, maybe it's a custom field named "QA Assignee" or the "Target version" field. When | started to think on this issue, |
wanted to show only the mandatory fields for next status which are not filled (in order to allow users to fill those fields before the validation), but it still
doesn't cover all the cases and | decided to keep it simple and maybe to work in future releases to a more complex way to configure transitions
buttons (how luxury_buttons plugin does).

#8 - 2020-04-06 06:50 - Bernhard Rohloff

| like the third approach most as | think my colleagues would recognize and adopt it very quickly.
Version 1 is too confusing for most of my users. Too much choice, you know. ;-) The second version is not visible enough to find it by yourself.

Robert Schneider wrote:

Hm... | always missed that feature.

However, it would be much better if the assignee could be set in the same step. E.g.: when | choose status 'solved' the assigne should be

automatically set to QA.

This sounds like a very good job for a custom script/bot which pushes your tickets to the right assignee based on your criteria. Something like the

Tasks engine in Nextcloud would be great for that use case, too.

#9 - 2020-04-06 08:22 - Go MAEDA

- Related to Feature #33254: Show open/closed badge on issue page added

#10 - 2021-02-09 03:23 - Mizuki ISHIKAWA
- File draft-3.patch added

- File select-status-if-required-assignee.gif added

I like the idea of 3, so | made a draft patch based on the idea of 3. Feedback is welcome.

If Assignee is required when changing to Assigned status by workflow settings, open the Edit page as shown in the following gif.

This is the same behavior as changing the status with the context menu.

select-status-if-required-assignee.gif

#11 - 2021-05-11 11:13 - Sunding Wei

Great thanks to Mizuki ISHIKAWA, the patch works for redmine 4.2, it greatly improves productivity!

#12 - 2023-09-26 16:11 - Dmitry Beloglazov

This feature would be really helpful!
Is there a working patch / plugin for Redmine 5?

Seems that the patch by Mizuki ISHIKAWA is not compatible with version 5, and | couldn't get the latest version of "status button" plugin working, tried

this one: https://github.com/asannou/redmine_status_button

#13 - 2024-09-22 09:39 - Michael Aram

+1
